package co.yixiang.yshop.module.member.dal.mysql.signinrecord;

import java.util.*;

import co.yixiang.yshop.framework.common.pojo.PageResult;
import co.yixiang.yshop.framework.mybatis.core.query.LambdaQueryWrapperX;
import co.yixiang.yshop.framework.mybatis.core.mapper.BaseMapperX;
import co.yixiang.yshop.module.member.dal.dataobject.signinrecord.SignInRecordDO;
import org.apache.ibatis.annotations.Mapper;
import co.yixiang.yshop.module.member.controller.admin.signinrecord.vo.*;

/**
 * 签到记录 Mapper
 *
 * @author admin
 */
@Mapper
public interface SignInRecordMapper extends BaseMapperX<SignInRecordDO> {

    default PageResult<SignInRecordDO> selectPage(SignInRecordPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<SignInRecordDO>()
                .eqIfPresent(SignInRecordDO::getUserId, reqVO.getUserId())
                .eqIfPresent(SignInRecordDO::getIntegral, reqVO.getIntegral())
                .betweenIfPresent(SignInRecordDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(SignInRecordDO::getId));
    }

    default List<SignInRecordDO> selectList(SignInRecordExportReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<SignInRecordDO>()
                .eqIfPresent(SignInRecordDO::getUserId, reqVO.getUserId())
                .eqIfPresent(SignInRecordDO::getIntegral, reqVO.getIntegral())
                .betweenIfPresent(SignInRecordDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(SignInRecordDO::getId));
    }

}
